# -*- coding: utf-8 -*-
from SimpleCV import *

#OK!
def findLines(img, threshold, minlinelength):
    lines = img.findLines(threshold, minlinelength)
    if(lines):
        lines.draw(color=Color.RED,width=3)
        #img.show()
    return lines


#OK!
def findCircle(img):
    dist = img.colorDistance(Color.WHITE).dilate(2)
    segmented = dist.stretch(200,255)
    blobs = dist.findBlobs()


    #dist.show()
    if(blobs): # if blobs are found
            circles = blobs.filter([b.isCircle(1.0) for b in blobs]) # filter out only circle shaped blobs
            if circles:
                img.drawCircle((circles[-1].x, circles[-1].y), circles[-1].radius(),Color.RED,3)
                
                print "True para circle"
                return img
    print "False para circle"
    return None



#OK! - extract method to: findCircleWithEqualMeanColor(img, minimum_color)
def findBlackCircle(img):
    minimum_color = (230.0, 230.0, 230.0) #minimum black color tuple    

    dist = img.colorDistance(Color.WHITE).dilate(2)
    segmented = dist.stretch(200,255)
    blobs = dist.findBlobs()
    dist.show()
    #dist.show()
    if(blobs): # if blobs are found
            circles = blobs.filter([b.isCircle(1.0) for b in blobs]) # filter out only circle shaped blobs
            if circles:
                circle = circles[-1]
                img.drawCircle((circles[-1].x, circles[-1].y), circles[-1].radius(),Color.RED,3)

                mean_color = circle.meanColor() #getting the mean color of the circle

                diference_color_r = mean_color[0] - minimum_color[0]
                diference_color_g = mean_color[1] - minimum_color[1]
                diference_color_b = mean_color[2] - minimum_color[2]

                if(diference_color_r > 0 and diference_color_g > 0 and diference_color_b > 0):
                    print mean_color
                    return img
    print "False para circle"
    return None

#OK! +-
def findRectangle(img):
    blobs = img.findBlobs()
    if(blobs):
        rectangles = blobs.filter([b.isRectangle(5.0) for b in blobs])
        if(len(rectangles) > 0):
            blobs[-1].drawRect(None, (255,0,0),3,128)
            print "Deu True pra retangulo"
            return True
    print "Deu False pra retangulo"
    return False

#OK!
def findSquare(img):
    blobs = img.findBlobs()
    if(blobs):
        squares = blobs.filter([b.isSquare(5.0) for b in blobs])
        if(len(squares) >= 1):
            blobs[0].drawRect(None, (255,0,0),3,128)
            #print "Deu True pra quadrado"
            return squares[0]
    #print "Deu False pra quadrado"
    return None


#OK! - extract method to: 
def findBlackSquare(img):
    minimum_color = (230.0, 230.0, 230.0) #minimum black color tuple
    
    blobs = img.findBlobs()
    if(blobs):
        squares = blobs.filter([b.isSquare(1.0) for b in blobs])
        if(len(squares) >= 1):
            blobs[0].drawRect(None, (255,0,0),3,128)
            #print "Deu True pra quadrado"
            return squares[0]
    #print "Deu False pra quadrado"
    return None


def findDegradeOnSquare(img):
    img = img.pixelize(20,None,None,False)
    img = getSquareCroppedImg(img)
    
    pixel_begin = img.getPixel(2,2)
    pixel_last = img.getPixel(img.width -1,img.height -1)
    
    nivel_max_de_correcao = 40.0
    nivel_min_de_correcao = -40.0
    
    scale_red = pixel_begin[0] - pixel_last[0]
    scale_green = pixel_begin[1] - pixel_last[1]
    scale_blue = pixel_begin[2] - pixel_last[2]
    
    if(scale_red > nivel_min_de_correcao and scale_red < nivel_max_de_correcao):
        if(scale_green > nivel_min_de_correcao and scale_green < nivel_max_de_correcao):
            if(scale_blue > nivel_min_de_correcao and scale_blue < nivel_max_de_correcao):
                return None
    #Eh degrade
    return img


def getSquareCroppedImg(img):
    imgBin = img.binarize()
    square = findSquare(imgBin)
    imgCrop = None
    if(square):
        square_area = square.area()
        square_x = square.topLeftCorner()[0]
        square_y = square.topLeftCorner()[1]
        square_height = square.height()
        square_width = square.width()
        imgCrop = img.crop(square_x, square_y, square_width, square_height, False)
        return imgCrop
    return imgCrop
