import java.awt.Color;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.microedition.xlet.Xlet;
import javax.microedition.xlet.XletContext;
import javax.microedition.xlet.XletStateChangeException;

import plaver.dtvtest.DTVTestController;
import plaver.dtvtest.DTVTestEvent;
import plaver.dtvtest.DTVTestListener;
import plaver.qrcode.BitToString;
import plaver.qrcode.MatrizImgQR;
import plaver.qrcode.QRCode;

import com.sun.dtv.lwuit.Font;
import com.sun.dtv.lwuit.Form;
import com.sun.dtv.lwuit.Graphics;
import com.sun.dtv.lwuit.Image;
import com.sun.dtv.lwuit.Label;
import com.sun.dtv.lwuit.geom.Dimension;
import com.sun.dtv.lwuit.layouts.CoordinateLayout;
import com.sun.dtv.lwuit.plaf.Style;
import com.sun.dtv.ui.Capabilities;
import com.sun.dtv.ui.Device;
import com.sun.dtv.ui.Plane;
import com.sun.dtv.ui.PlaneSetup;
import com.sun.dtv.ui.Screen;

public class TestSuitXlet implements Xlet, DTVTestListener {
	
	private Form form;

	private List controllerList = new ArrayList();
	private int  cIndex = 0;
	
	private int qtdApps;
	private int qtdAutoApps; /* Apenas aplicaes automticas (i.e., visuais) *
							  * faro parte do QR Code 						 */
	
	private boolean[] boolVector;
	private int		  contBoolList;
	private int 	  contCurrentAPP = 1;
	
	private Font 	 font;
	private Graphics grapCont;
	
	private XletContext contextXlet;

	public void initXlet(XletContext ctx) throws XletStateChangeException {
		this.contextXlet = ctx;
		
		form = new Form();
		setPlane(form);
		
		controllerList = DTVTestController.createTestSuit("apps.txt", form, contextXlet);
		qtdApps = controllerList.size();
		qtdAutoApps = DTVTestController.getQtdAutoApps();
		
	}

	private void setPlane(Form form) {
		
		Device device = Device.getInstance();
		Screen currentScreen = device.getDefaultScreen();
		PlaneSetup planeSetup = null;
		Plane[] planes = currentScreen.getAllPlanes();
		
		for(int i=0; i < planes.length; i++) {
			Capabilities cap = planes[i].getCapabilities();
			if(cap.isGraphicsRenderingSupported()) {
				Plane plane = planes[i];
				planeSetup = plane.getCurrentSetup();
		
				break;
			}
		}
		
		Style  style = new Style();
		style.setBgColor(Color.WHITE);
		form.setStyle(style);
		form.setLayout(new CoordinateLayout(planeSetup.getScreenResolution()));
				
	}
	
	public void startXlet() throws XletStateChangeException {
		
		exibeImagemInicial();
		
		DTVTestController controller; 
		Iterator it = controllerList.iterator();

		boolVector = new boolean[qtdAutoApps];
		
		while (it.hasNext()) {
			controller = (DTVTestController) it.next();
			controller.addDTVTestEventListener(this);
		}	
		
		exibeImgExecucao();
		exibeContador();
		
		( (DTVTestController)  controllerList.get(cIndex++)).start();
	}

	
	public void testLogEventReceived(DTVTestEvent e) {
		
		if(e.getStatus() == DTVTestEvent.TEST_SUCCESS)
			boolVector[contBoolList++] = true;
		else if(e.getStatus() == DTVTestEvent.TEST_FAILURE || e.getStatus() == DTVTestEvent.TEST_TIMEOUT)
			boolVector[contBoolList++] = false;
		
		if (cIndex < controllerList.size()) {
			exibeContador();
			( (DTVTestController) controllerList.get(cIndex++)).start();
		} else {
			exibeImagemFinal();
			exibeQRCode();
		}
			
	}

	private void exibeImagemInicial() {
		
        Label labInit = new Label();
        labInit.setSize(new Dimension(form.getWidth(), form.getHeight()));
        labInit.getStyle().setBgColor(Color.WHITE);
        
        font = Font.createSystemFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, 50);
        
        try {
			Image imgInit = Image.createImage("plaver/imagens/inicio.png");
			imgInit = imgInit.scaled(form.getWidth()/100 * 40,  form.getWidth()/100 * 40);
			
			Image imgBack = Image.createImage(form.getWidth(), form.getHeight());
			Graphics gBack = imgBack.getGraphics();
			gBack.drawImage(imgInit, (form.getWidth() - imgInit.getWidth())/2, (form.getHeight() - imgInit.getHeight())/2);
			
			labInit.setIcon(imgBack);
			
			form.addComponent(labInit);
			form.show();
			
			try {
				Thread.sleep(5000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void exibeContador() {

		grapCont.setColor(Color.WHITE);
//		grapCont.fillRect(725, 135, 100, 70);
		grapCont.fillRect( (int) (form.getWidth()/1.55), form.getHeight()/5, form.getWidth()/6, form.getHeight()/8);
		
		grapCont.setColor(Color.BLACK);		

		if(contCurrentAPP > 99) {
			grapCont.drawString("Executanto Teste: "  + contCurrentAPP , 350, 140);
		} else if(contCurrentAPP > 9) {
			grapCont.drawString("Executanto Teste: 0"  + contCurrentAPP , 350, 140);
		} else {
			grapCont.drawString("Executanto Teste: 00"  + contCurrentAPP , 350, 140);
		}
		
		contCurrentAPP++;
		form.show();
	}

	private void exibeImgExecucao() {
		
		Label logo = new Label();
		logo.getStyle().setBgTransparency(0);
		logo.setSize(new Dimension(250,200));
		logo.setX((int)(form.getWidth()*0.96) - logo.getWidth());
		logo.setY(form.getHeight() - logo.getHeight());
		
		Label labExec = new Label();
		labExec.setSize(new Dimension(form.getWidth(), form.getHeight()));
		labExec.setY(form.getHeight()/6);
		
		labExec.getStyle().setBgColor(Color.WHITE);
		grapCont = null;
		
        try {
			
			logo.setIcon(Image.createImage("plaver/imagens/logo.png"));
			
			Image imgBgExec = Image.createImage(form.getWidth(), form.getHeight());
			grapCont = imgBgExec.getGraphics();
			
			grapCont.setColor(Color.BLACK);
			grapCont.setFont(font);
			
			if(qtdApps > 99) {
				grapCont.drawString("Sute de Testes 01 (" + qtdApps + " Aplicaes)" , 245, 50);
			} else if(qtdApps > 9) {
				grapCont.drawString("Sute de Testes 01 (" + qtdApps + " Aplicaes)" , 245, 50);
			} else {
				grapCont.drawString("Sute de Testes 01 (" + qtdApps + " Aplicaes)" , 245, 50);
			}
			
			labExec.setIcon(imgBgExec);
			
        } catch (IOException e) {
			e.printStackTrace();
		}
        
        form.removeAll();
		form.addComponent(labExec);
        form.addComponent(logo);
		
		form.show();

	}
	
	private void exibeImagemFinal() {
		form.removeAll();
		
        Label labelEnd = new Label();
        labelEnd.setSize(new Dimension(form.getWidth(), form.getHeight()));
        labelEnd.getStyle().setBgColor(Color.WHITE);
       
        try {
			Image imgEnd = Image.createImage("plaver/imagens/fim.png");
			labelEnd.setIcon(imgEnd);
			
			form.addComponent(labelEnd);
			form.show();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void exibeQRCode() {
		String strResult = "";
		
		/* No h nenhuma aplicao no visual para ser apresentada no QR Code*/
		if(boolVector.length == 0)
			return;
		
		BitToString bitToString = new BitToString();
		bitToString.addBits(boolVector);
		
		strResult = bitToString.getString();
		
//		imprimeDebuger(strResult, boolVector);
		
		Label bbbImage = new Label();

		QRCode qr = new QRCode(2, 3, 2, strResult);
		qr.init();
		
		Image imagem = null;
		try {
			imagem = MatrizImgQR.GerarImagem(qr.getVector(), qr.getVersion(), qr.getEccLevel(), 14);
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		
		bbbImage.setX((int)(form.getWidth()/2.05) - imagem.getWidth()/2);
		bbbImage.setY((int)(form.getHeight()/1.55) - imagem.getHeight()/2);
		bbbImage.getStyle().setBgColor(Color.WHITE);
		bbbImage.setIcon(imagem);
		
		form.addComponent(bbbImage);
		form.repaint();
	}
	
	/* Exibe na tela informaes como: String codificada e lista de resultados das aplicaes no-visuais */
//	private void imprimeDebuger(String strResult, boolean[] boolVector) {
//		
//		int cont = 1;
//		
//		Label texto = new Label();
//		texto.setText(strResult);
//		texto.setX(30);
//		texto.setY(10);
//		form.addComponent(texto);
//		
//		texto = new Label();
//		
//		strResult = "[";
//		for(int i = 0; i < (boolVector.length - 1); i++) {
//			
//			if(i%20 == 0 && i != 0) {
//				cont++;
//
//				texto = new Label();
//				texto.setX(30);
//				texto.setY(20*cont);
//				texto.setText(strResult);
//				
//				form.addComponent(texto);
//				strResult = " ";
//				
//			}
//			
//			strResult += boolVector[i] + ", ";
//		}
//		strResult += boolVector[boolVector.length - 1] + "]";
//		cont++;
//		
//		texto = new Label();
//		texto.setText(strResult);
//		texto.setX(30);
//		texto.setY(20*cont);
//		form.addComponent(texto);
//	}
	
	public void pauseXlet() {
		
	}
	
	public void destroyXlet(boolean unconditional)
			throws XletStateChangeException {
	}
}
