package plaver.com.sun.dtv.ui.Screen;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ResourceTypeListener;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.Device;
import com.sun.dtv.ui.Screen;


/**
 * @author Leandro Henrique
 */

public class AddResourceTypeListenerTest implements DTVTest, ResourceTypeListener, ScarceResourceListener{
		
	private DTVTestLog dtvTestLog;
	
	private boolean  eventoRecedido;
	private Screen currentScreen;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		Device device = Device.getInstance();
		currentScreen = device.getDefaultScreen();
	}

	/**
	 * Ser gerado um evento de release. Caso o listener adicionado seja notificado, o teste foi realizado com sucesso.
	 * Caso contrrio, a instncia ir gerar timeout.
	 */
	public void start() {

		Screen.addResourceTypeListener(this);

		if( ! currentScreen.isAvailable())
			currentScreen.release();
			
		try {
			currentScreen.reserve(true, -1, this);
		} catch (IllegalArgumentException e2) {
			e2.printStackTrace();
		} catch (TimeoutException e2) {
			e2.printStackTrace();
		}
		
		/* Espera o evento ser recebido */
		while( ! eventoRecedido) {
			
			try {
				Thread.sleep(300);
			} catch (InterruptedException e) {
				e.printStackTrace();
				break;
			}
			
		}

		if(eventoRecedido)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}
	
	public void reserved(int availableCount) {
		/* Evento foi recebido corretamente */
		eventoRecedido = true;
	}

	public void released(int availableCount) {
		// TODO Auto-generated method stub
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		Screen.removeResourceTypeListener(this);
		
		if( ! currentScreen.isAvailable())
			currentScreen.release();
	}


	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}

