package plaver.com.sun.dtv.ui.Screen;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.Device;
import com.sun.dtv.ui.Screen;


public class AddScarceResourceListenerTest implements DTVTest, ScarceResourceListener {

	private DTVTestLog dtvTestLog;
	private Screen currentScreen;
	
	private boolean eventoRecebido_1;
	private boolean eventoRecebido_2;
	private boolean eventoRecebido_3;
	
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		Device device = Device.getInstance();
		currentScreen = device.getDefaultScreen();
	}

	public void start() {
		
		currentScreen.addScarceResourceListener(this);
		
		if( ! currentScreen.isAvailable())
			currentScreen.release();
		
		try {
			currentScreen.reserve(false, -1, this);
			currentScreen.reserve(true , -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}
		
		currentScreen.release();
		
		if(eventoRecebido_1 == eventoRecebido_2 == eventoRecebido_3 == true)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}

	public boolean releaseRequested(ScarceResource resource) {
		eventoRecebido_1 = true;
		return false; /* Recurso no liberado */
	}
	
	public void releaseForced(ScarceResource resource) {
		eventoRecebido_2 = true;
	}
	
	public void released(ScarceResource resource) {
		eventoRecebido_3 = true;
	}

	public void pause() {
		// TODO Auto-generated method stub
		
	}

	public void destroy() {
		// TODO Auto-generated method stub
		
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}


}
