package plaver.com.sun.dtv.ui.event.KeyEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;

/**
 * @author Leandro Henrique
 */

public class IsAvailableTest implements DTVTest, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	private KeyEvent   recursoKE;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		determinaEventoKE();
	}


	public void start() {
		boolean isAvailable_1 = false;
		boolean isAvailable_2 = false;

		try {
			recursoKE.reserve(true, -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}

		if(recursoKE.isAvailable() == false)
			isAvailable_1 = true;
		
		recursoKE.release();
		
		if(recursoKE.isAvailable() == true)
			isAvailable_2 = true;
		
		
		if(isAvailable_1 == isAvailable_2 == true)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
	}

	/** 
	 *  Verifica o mtodo isAvailable antes e depois do recurso ser reservado
	 */
	private void determinaEventoKE() {
		recursoKE = new KeyEvent(null, 		  			  //Componente que originou o evento
				java.awt.event.KeyEvent.KEY_RELEASED,     //Tipo de evento
				0,										  //Tempo que o evento ocorreu
				0,										  //Modificadores
				KeyEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
				KeyEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
				);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		
		if( ! recursoKE.isAvailable())
			recursoKE.release();
		
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

}
