package plaver.com.sun.dtv.ui.event.KeyEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;

/**
 * @author Leandro Henrique
 */

public class ReleaseTest implements DTVTest, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	private KeyEvent   recursoKE;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		determinaEventoKE();
		
		try {
			recursoKE.reserve(true, -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}

	}

	/** 
	 *  Um recurso anteriormente reservado ser liberado atravs do mtodo {@link KeyEvent#release()}. O mtodo obter sucesso se
	 *  a recurso estiver disponvel posteriormente.
	 */
	public void start() {

		recursoKE.release();
		
		if(recursoKE.isAvailable())
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}
	
	
	private void determinaEventoKE() {
		recursoKE = new KeyEvent(null, 		  			  //Componente que originou o evento
				java.awt.event.KeyEvent.KEY_RELEASED,     //Tipo de evento
				0,										  //Tempo que o evento ocorreu
				0,										  //Modificadores
				KeyEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
				KeyEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
				);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		// TODO Auto-generated method stub
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}


}
