package plaver.com.sun.dtv.ui.event.KeyEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ResourceTypeListener;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;

/**
 * @author Leandro Henrique
 */

public class RemoveResourceTypeListenerTest implements DTVTest, ResourceTypeListener, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	
	private KeyEvent recursoKE;
	private boolean  eventoRecedido;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		// TODO Auto-generated method stub
	}
	
	/**
	 * Ser reservado um recurso. Caso o listener removido no seja notificado, o teste foi realizado com sucesso.
	 */
	public void start() {
		KeyEvent.addResourceTypeListener(this);
		KeyEvent.removeResourceTypeListener(this);
		
		determinaEventoKE();
		if( ! recursoKE.isAvailable())
			recursoKE.release();
		
		try {
			recursoKE.reserve(true, -1, this);
		} catch (IllegalArgumentException e1) {
			e1.printStackTrace();
		} catch (TimeoutException e1) {
			e1.printStackTrace();
		}
		
		try {
			/* Espera o evento ser recebido */
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		if(eventoRecedido)
			dtvTestLog.failure();
		else
			dtvTestLog.success();
		
	}
	
	public void reserved(int availableCount) {
		eventoRecedido = true;
	}

	public void released(int availableCount) {
		// TODO Auto-generated method stub
	}
	
	
	private void determinaEventoKE() {
		recursoKE = new KeyEvent(null, 		  			  //Componente que originou o evento
				java.awt.event.KeyEvent.KEY_RELEASED,     //Tipo de evento
				0,										  //Tempo que o evento ocorreu
				0,										  //Modificadores
				KeyEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
				KeyEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
				);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		if( ! recursoKE.isAvailable())
			recursoKE.release();
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
		
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
		
	}


}
