package plaver.com.sun.dtv.ui.event.KeyEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;

/**
 * @author Leandro Henrique
 */

public class ReserveOneTest implements DTVTest, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	
	private KeyEvent recursoKE;
	private int	     keyCode;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		keyCode = KeyEvent.VK_UNDEFINED;
		determinaEventoKE();
	}


	/**
	 * Um recurso com um keyCode especfico ser liberado atravs do mtodo {@ KeyEvent#release()}
	 * Posteriormente este mtodo tentar reservar um recurso com o mesmo keyCode. Caso este recurso seja reservado,
	 * o mtodo obter xito.
	 */
	public void start() {
		
		if( ! recursoKE.isAvailable())
			recursoKE.release();
		
		try {
			recursoKE = KeyEvent.reserveOne(KeyEvent.VK_UNDEFINED, true, -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}
		
		if( ! recursoKE.isAvailable() && recursoKE.getKeyCode() == keyCode)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}
	
	private void determinaEventoKE() {
		recursoKE = new KeyEvent(null, 		  			  //Componente que originou o evento
				java.awt.event.KeyEvent.KEY_RELEASED,     //Tipo de evento
				0,										  //Tempo que o evento ocorreu
				0,										  //Modificadores
				keyCode,		  			  			  //Recurso utilizado pelo evento
				KeyEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
				);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		recursoKE.release();
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}


}
