package plaver.com.sun.dtv.ui.event.KeyEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;


/**
 * @author Leandro Henrique
 */

public class ReserveTest implements DTVTest, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	private KeyEvent   recursoKE;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		determinaEventoKE();
	}

	/** 
	 *  Um recurso anteriormente liberado ser reservado atravs do mtodo {@link KeyEvent#reserve(boolean, long, ScarceResourceListener).
	 *  O mtodo obter sucesso se o recurso no estiver disponvel posteriormente e se no ocorrer erros.
	 */
	public void start() {
		
		if( ! recursoKE.isAvailable())
			recursoKE.release();
		
		try {
			recursoKE.reserve(true, -1, this);
		} catch (IllegalArgumentException e) {
			dtvTestLog.failure();
		} catch (TimeoutException e) {
			dtvTestLog.failure();
		}
		
		if(recursoKE.isAvailable() == false)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}
	
	private void determinaEventoKE() {
		recursoKE = new KeyEvent(null, 		  			  //Componente que originou o evento
				java.awt.event.KeyEvent.KEY_RELEASED,     //Tipo de evento
				0,										  //Tempo que o evento ocorreu
				0,										  //Modificadores
				KeyEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
				KeyEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
				);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		recursoKE.release();
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

}
