package plaver.com.sun.dtv.ui.event.RemoteControlEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ResourceTypeListener;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.RemoteControlEvent;

/**
 * @author Leandro Henrique
 */

public class AddResourceTypeListenerTest implements DTVTest, ResourceTypeListener, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	
	private RemoteControlEvent recursoRCE;
	private boolean  eventoRecedido;
	
	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		determinaEventoRCE();
	}


	/**
	 * Ser gerado um evento de release. Caso o listener adicionado seja notificado, o teste foi realizado com sucesso.
	 */
	public void start() {
		RemoteControlEvent.addResourceTypeListener(this);
	
		if( ! recursoRCE.isAvailable())
			recursoRCE.release();
		
		try {
			recursoRCE.reserve(true, -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}
		
		/* Espera o evento ser recebido */
		while( ! eventoRecedido) {
			
			try {
				Thread.sleep(300);
			} catch (InterruptedException e) {
				e.printStackTrace();
				break;
			}
			
		}

		if(eventoRecedido)
			dtvTestLog.success();
		else
			dtvTestLog.failure();

	}

	public void reserved(int availableCount) {
		/* Evento foi recebido corretamente */
		eventoRecedido = true;
	}
	
	public void released(int availableCount) {
		// TODO Auto-generated method stub
	}
	
	private void determinaEventoRCE() {
		recursoRCE = new RemoteControlEvent(null, 		  					  //Componente que originou o evento
						java.awt.event.KeyEvent.KEY_RELEASED,     			  //Tipo de evento
						0,										  			  //Tempo que o evento ocorreu
						0,										 			  //Modificadores
						RemoteControlEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
						RemoteControlEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
					);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		recursoRCE.release();
		RemoteControlEvent.removeResourceTypeListener(this);
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

}
