package plaver.com.sun.dtv.ui.event.RemoteControlEvent;
 
import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ResourceTypeListener;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.RemoteControlEvent;

/**
 * @author Leandro Henrique
 */

public class RemoveResourceTypeListenerTest implements DTVTest, ResourceTypeListener, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	
	private RemoteControlEvent recursoRCE;
	private boolean  eventoRecedido;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		// TODO Auto-generated method stub
	}

	/**
	 * Ser gerado um evento de release. Caso o listener adicionado seja notificado, o teste foi realizado com sucesso.
	 */
	public void start() {
		
		RemoteControlEvent.addResourceTypeListener(this);
		RemoteControlEvent.removeResourceTypeListener(this);
		
		determinaEventoRCE();
		if( ! recursoRCE.isAvailable())
			recursoRCE.release();
		
		try {
			recursoRCE.reserve(true, -1, this);
		} catch (IllegalArgumentException e1) {
			e1.printStackTrace();
		} catch (TimeoutException e1) {
			e1.printStackTrace();
		}
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		if(eventoRecedido)
			dtvTestLog.failure();
		else
			dtvTestLog.success();
	}
	
	public void released(int availableCount) {
		eventoRecedido = true;
	}
	
	private void determinaEventoRCE() {
		recursoRCE = new RemoteControlEvent(null, 		  					  //Componente que originou o evento
						java.awt.event.KeyEvent.KEY_RELEASED,     			  //Tipo de evento
						0,										  			  //Tempo que o evento ocorreu
						0,										 			  //Modificadores
						RemoteControlEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
						RemoteControlEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
					);
	}
	
	public void reserved(int availableCount) {
		eventoRecedido = true;
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		recursoRCE.release();
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

}
