package plaver.com.sun.dtv.ui.event.RemoteControlEvent;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.resources.TimeoutException;
import com.sun.dtv.ui.event.KeyEvent;
import com.sun.dtv.ui.event.RemoteControlEvent;


/**
 * @author Leandro Henrique
 */

public class ReserveOneTest implements DTVTest, ScarceResourceListener {
		
	private DTVTestLog dtvTestLog;
	
	private KeyEvent recursoRCE;
	private int	     keyCode;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		keyCode = RemoteControlEvent.VK_UNDEFINED;
		determinaEventoRCE();
	}


	/**
	 * Um recurso com um keyCode especfico ser liberado atravs do mtodo {@ RemoteControlEvent#release()}
	 * Posteriormente este mtodo tentar reservar um recurso com o mesmo keyCode. Caso este recurso seja reservado,
	 * o mtodo obter xito.
	 */
	public void start() {

		try {
			recursoRCE = KeyEvent.reserveOne(RemoteControlEvent.VK_UNDEFINED, true, -1, this);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (TimeoutException e) {
			e.printStackTrace();
		}
		
		if( ! recursoRCE.isAvailable() && recursoRCE.getKeyCode() == keyCode)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
	}

	private void determinaEventoRCE() {
		recursoRCE = new RemoteControlEvent(null, 		  					  //Componente que originou o evento
						java.awt.event.KeyEvent.KEY_RELEASED,     			  //Tipo de evento
						0,										  			  //Tempo que o evento ocorreu
						0,										 			  //Modificadores
						RemoteControlEvent.VK_UNDEFINED,		  			  //Recurso utilizado pelo evento
						RemoteControlEvent.CHAR_UNDEFINED					  //Caracter unicode que gerou o evento
					);
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		recursoRCE.release();
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}


}
