package plaver.com.sun.dtv.ui.event.UserInputEventManager;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.resources.ScarceResource;
import com.sun.dtv.resources.ScarceResourceListener;
import com.sun.dtv.ui.Device;
import com.sun.dtv.ui.Screen;
import com.sun.dtv.ui.event.RemoteControlEvent;
import com.sun.dtv.ui.event.UserInputEvent;
import com.sun.dtv.ui.event.UserInputEventListener;
import com.sun.dtv.ui.event.UserInputEventManager;

public class GetUserInputEventManagerTest implements DTVTest, UserInputEventListener, ScarceResourceListener {

	private DTVTestLog dtvTestLog;
	
	private UserInputEventManager eventManager;
	private RemoteControlEvent eventoRCE;
	private Device device;
	private Screen currentScreen;
	

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}
	
	public void init() {
		device = Device.getInstance();
		currentScreen = device.getDefaultScreen();
		eventManager = UserInputEventManager.getUserInputEventManager(currentScreen);
	}

	/**
	 * Aps adicionar um novo listener, ser verificado, a partir do mtodo {@link UserInputEventManager#getUserInputEventManager(Screen)},
	 * se o listener retornado  o mesmo previamente adicionado.
	 */
	public void start() {
		
		determinaEventoRCE();
		
		eventManager.addUserInputEventListener(this, eventoRCE);
		UserInputEventManager managerReceived = UserInputEventManager.getUserInputEventManager(currentScreen);
		
		if(managerReceived == eventManager)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}	

	/**
	 * Instancia um evento de usurio atravs da classe {@link RemoteControlEvent RemoteControlEvent}
	 */
	private void determinaEventoRCE() {
		eventoRCE = new RemoteControlEvent(null, 		  //Componente que originou o evento
        		RemoteControlEvent.KEY_RELEASED,          //Tipo de evento
        		0,										  //Tempo que o evento ocorreu
        		0,										  //Modificadores
        		RemoteControlEvent.VK_COLORED_KEY_0,	  //Recurso utilizado pelo evento (VK_UNDEFINED no est implementado)
        		RemoteControlEvent.CHAR_UNDEFINED		  //Caracter unicode que gerou o evento
        );
	}

	public void pause() {
		// TODO Auto-generated method stub
	}
	
	public void destroy() {
		eventManager.removeUserInputEventListener(this);
		eventoRCE.release();
	}

	public boolean releaseRequested(ScarceResource resource) {
		// TODO Auto-generated method stub
		return false;
	}

	public void releaseForced(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void released(ScarceResource resource) {
		// TODO Auto-generated method stub
	}

	public void userInputEventReceived(UserInputEvent event) {
		// TODO Auto-generated method stub
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}
