package plaver.debuger;

import com.sun.dtv.lwuit.Form;
import com.sun.dtv.lwuit.Label;
import com.sun.dtv.lwuit.geom.Dimension;


/**
 * Classe que axilia a depurao do programa atravs de mensagens na tela em tempo de execuo.
 * 
 * Exemplo:
 * 
 * Debuger debuger = new Debuger(meuForm);
 * ... Cdigo ...
 * debuger.showBreakPoint("Mensagem a ser exibida na tela por um tempo determinado");
 * ... Cdigo ...
 * 
 * @author Leandro
 */
public class Debuger {
	
	private Form form;
	
	private Label labMessage;
//	private Label labFaker; //Gambiarra para o labMessage ficar mais abaixo
	
	private long time = 5000;
	private int contador; // Nmero de vezes que showBreakPoint(String msg) foi executado
	
	public Debuger(Form form) {
		this.form = form;
		
		labMessage = new Label();
		
		/* New */
//		labFaker = new Label();
//		labFaker.setSize(new Dimension(120,120));

//		form.addComponent(labFaker);
		form.addComponent(labMessage);
		
	}
	
	public void showBreakPoint(String msg) {
		
		String strContador = String.valueOf(++contador);
		String aux = strContador.concat(" - ").concat(msg);
		
		labMessage.setText(aux);
		labMessage.setX(30);
		labMessage.setY(60);
		
		form.show();
		form.repaint();
		
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

}

