package plaver.javax.media.Manager;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.media.Manager;
import javax.media.MediaLocator;
import javax.media.NoDataSourceException;
import javax.media.protocol.DataSource;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;


/**
 * @author Leandro Henrique
 */

public class CreateDataSource_2Test implements DTVTest {
		
	private static final String LOCATOR = "file://plaver/javax/media/Manager/medias_jmf/v2.MPG";
//	private static final String LOCATOR = "dtv://1.1.1";

	private DTVTestLog dtvTestLog;
	private DataSource dataSource;
	private URL url;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}


	public void init() {
		
		try {
			url = new URL(CreateDataSource_2Test.LOCATOR);
			dataSource = Manager.createDataSource(new MediaLocator(url));
		} catch (NoDataSourceException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	/** Testa createDataSource() atravs da seguinte forma de sobrecarga: 
	 *	<ul>
	 *  <li>Manager.createDataSource(MediaLocator mediaLocator)</li>
	 *	</ul>
	 *  
	 *  <p>Para realizar o teste, primeiramente, ser verificado se o retorno  uma instncia de <code>DataSourde</code>. Aps isso,
	 *  ser verificado se a <code>URL</code> pertencente ao <code>DataSource</code>  o mesmo anteriormente especificado.</p>
	 *  
	 *  @throws MalformedURLException 
	 *  @see {@link Manager#createDataSource(MediaLocator)}
	 */
	public void start() {
		
		if(dataSource instanceof DataSource) {
			
			try {
				dataSource.connect();
				dataSource.start();
				dataSource.stop();
				dataSource.disconnect();
				
				/* No dever haver erros */
				dtvTestLog.success();
				
			} catch(Exception e) {
				dtvTestLog.failure();
			}

		} else {
			dtvTestLog.failure();
		}
		
	}

	public void pause() {
		// TODO Auto-generated method stub
	}


	public void destroy() {
		// TODO Auto-generated method stub
	}


	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}