package plaver.javax.media.Manager;

import java.io.IOException; 
import java.net.MalformedURLException;
import java.net.URL;

import javax.media.Manager;
import javax.media.MediaLocator;
import javax.media.NoPlayerException;
import javax.media.Player;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;


/**
 * @author Leandro Henrique
 */

public class CreatePlayer_2Test implements DTVTest {
		
	private static final String LOCATOR = "file:plaver/javax/media/Manager/medias_jmf/v2.MPG";

	private DTVTestLog dtvTestLog;
	private Player player;
	
	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}

	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		
		
		try {
			player = Manager.createPlayer(new MediaLocator(LOCATOR).getURL());
		} catch (NoPlayerException e) {
			e.printStackTrace();
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void start() {
		try {
			testaMetodo();
		} catch (InterruptedException e) {
			e.printStackTrace();
			dtvTestLog.failure();
		}
	}


	/** Testa createPlayer() atravs da seguinte forma de sobrecarga: 
	 *	<ul>
	 *	<li>Manager.createPlayer(URL url)</li>
	 *	</ul>
	 * 
	 *  <p>Ser verificado se o retorno  uma instncia de <code>Player</code>. Aps isso, ser realizado uma srie
	 *  de operaes com o mesmo.
	 *  
	 * 	@throws InterruptedException 
	 *  @see Manager#createPlayer(URL)
	 */
	private void testaMetodo() throws InterruptedException  {

		if( player instanceof Player) {
			
			/* Manipula Player */
			player.realize();
			player.start();
			player.stop();
			player.close();

			dtvTestLog.success();
		} else {
			player.stop();
			
			player.close();
			dtvTestLog.failure();
		}	
		
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		// TODO Auto-generated method stub
	}


}
