package plaver.javax.media.Manager;

import java.io.IOException;

import javax.media.Manager;
import javax.media.MediaLocator;
import javax.media.NoDataSourceException;
import javax.media.NoPlayerException;
import javax.media.Player;
import javax.media.protocol.DataSource;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;


/**

 * @author Leandro Henrique
 *
 */

public class CreatePlayer_3Test implements DTVTest {
		
	private static final String LOCATOR = "file:plaver/javax/media/Manager/medias_jmf/v3.MPG";

	private DTVTestLog dtvTestLog;
	private Player player;
	private DataSource dataSource;

	public void setForm(Form form) {
		// TODO Auto-generated method stub
	}
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}
	
	public void init() {

		try {
			
			dataSource = Manager.createDataSource(new MediaLocator(LOCATOR));
			player	   = Manager.createPlayer(dataSource);
			
		} catch (NoPlayerException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (NoDataSourceException e) {
			e.printStackTrace();
		}
	}

	public void start() {
		try {
			testaMetodo();
		} catch (InterruptedException e) {
			e.printStackTrace();
			dtvTestLog.failure();
		}
	}


	/** Testa createPlayer() atravs da seguinte forma de sobrecarga: 
	 *	<ul>
	 *	<li>Manager.createPlayer(DataSource dataSource)</li>
	 *	</ul>
	 *  
	 *  <p>Ser verificado se o retorno  uma instncia de <code>Player</code>. Aps isso, ser realizado uma srie
	 *  de operaes com o mesmo.

	 *  @throws InterruptedException 
	 *  @see Manager#createPlayer(DataSource)
	 */
	private void testaMetodo() throws InterruptedException  {

		if( player instanceof Player) {

			/* Manipula Player */
			player.stop();
			player.close();
			
			dtvTestLog.success();
		} else {
			player.stop();
			player.close();

			dtvTestLog.failure();
		}
		
	}

	public void pause() {
		// TODO Auto-generated method stub
	}


	public void destroy() {
		// TODO Auto-generated method stub
	}


}
