package plaver.javax.tv.media.Awtvideosize;

import java.awt.Rectangle;

import javax.tv.media.AWTVideoSize;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;


/**
 * <code>TestaAWTVideoSize</code>  uma classe que inicia o teste para <strong>todos</strong> os mtodos de {@link AWTVideoSize}.
 * 
 * @author Leandro Henrique
 */

public class GetSourceTest implements DTVTest{
	
	private static final int WIDTH_SOURCE = 160;
	private static final int HEIGHT_SOURCE = 160;		
	private static final int X_SOURCE = 30;
	private static final int Y_SOURCE = 30;
	
	private static final int WIDTH_DEST = 95;
	private static final int HEIGHT_DEST = 75;		
	private static final int X_DEST = 30;
	private static final int Y_DEST = 20;
	
	private Rectangle videoSource;
	private Rectangle videoDest;
	private AWTVideoSize awtVideoSize;
	private DTVTestLog dtvTestLog;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		// TODO Auto-generated method stub
	}

	/** Testa getSource() verificando se o source (i.e. a posio e as dimenses original do vdeo) retornado  igual
	 *  ao source especificado no construtor.
	 *  
	 *  @see AWTVideoSize#getSource()
	 */
	public void start() {
		videoSource = new Rectangle(X_SOURCE, Y_SOURCE, WIDTH_SOURCE, HEIGHT_SOURCE);
		videoDest   = new Rectangle(X_DEST  , Y_DEST  , WIDTH_DEST  , HEIGHT_DEST);
		
		awtVideoSize = new AWTVideoSize(videoSource, videoDest);
		
		if(awtVideoSize.getSource().equals(videoSource))
			dtvTestLog.success();
		else
			dtvTestLog.failure();
		
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		// TODO Auto-generated method stub
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}
