package plaver.javax.tv.media.Awtvideosize;

import java.awt.Rectangle;

import javax.tv.media.AWTVideoSize;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;



/**
 * <code>TestaAWTVideoSize</code>  uma classe que inicia o teste para <strong>todos</strong> os mtodos de {@link AWTVideoSize}.
 * 
 * @author Leandro Henrique
 */

public class GetXScaleTest implements DTVTest{
	
	private static final int WIDTH_SOURCE = 200;
	private static final int HEIGHT_SOURCE = 160;		
	private static final int X_SOURCE = 30;
	private static final int Y_SOURCE = 30;
	
	private static final int WIDTH_DEST = 100;
	private static final int HEIGHT_DEST = 75;		
	private static final int X_DEST = 30;
	private static final int Y_DEST = 20;
	
	private Rectangle videoSource;
	private Rectangle videoDest;
	private AWTVideoSize awtVideoSize;
	private DTVTestLog dtvTestLog;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		// TODO Auto-generated method stub
	}
	
	/** Testa getGetXScale() verificando se a scala no eixo X corresponde  razo da largura final pela largura inicial do vdeo.
	 *  
	 *  @see AWTVideoSize#getXScale()
	 */
	public void start() {
		videoSource = new Rectangle(X_SOURCE, Y_SOURCE, WIDTH_SOURCE, HEIGHT_SOURCE);
		videoDest   = new Rectangle(X_DEST  , Y_DEST  , WIDTH_DEST  , HEIGHT_DEST);
		
		awtVideoSize = new AWTVideoSize(videoSource, videoDest);
		
		if(awtVideoSize.getXScale() == awtVideoSize.getDestination().width/ (float) awtVideoSize.getSource().width)
			dtvTestLog.success();
		else
			dtvTestLog.failure();
			
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		// TODO Auto-generated method stub
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}
