package plaver.javax.tv.media.Awtvideosize;

import java.awt.Rectangle;

import javax.tv.media.AWTVideoSize;

import com.sun.dtv.lwuit.Form;

import plaver.dtvtest.DTVTest;
import plaver.dtvtest.DTVTestLog;


/**
 * <code>TestaAWTVideoSize</code>  uma classe que inicia o teste para <strong>todos</strong> os mtodos de {@link AWTVideoSize}.
 * 
 * @author Leandro Henrique
 */

public class HashCodeTest implements DTVTest{
	
	private static final int WIDTH_SOURCE = 160;
	private static final int HEIGHT_SOURCE = 160;		
	private static final int X_SOURCE = 30;
	private static final int Y_SOURCE = 30;
	
	private static final int WIDTH_DEST = 95;
	private static final int HEIGHT_DEST = 75;		
	private static final int X_DEST = 30;
	private static final int Y_DEST = 20;
	
	private Rectangle videoSource;
	private Rectangle videoDest;
	private AWTVideoSize awtVideoSize;
	private DTVTestLog dtvTestLog;
	
	public void setLog(DTVTestLog log) {
		this.dtvTestLog = log;
	}

	public void init() {
		// TODO Auto-generated method stub
	}

	/** Testa hashCode() atravs de dois objetos do tipo AWTVideoSize. O primeiro  um clone do AWTVideoSize original, o segundo
	 *   um objeto com dimenes diferentes. O mtodo hashCode(), aplicado no objeto original, deve retornar <code>true</code>
	 *  quando comparado ao clone e retornar <code>false</code> ao ser comparado com o objeto diferente.  
	 *  
	 *  @see AWTVideoSize#hashCode()
	 */
	public void start() {
		videoSource = new Rectangle(X_SOURCE, Y_SOURCE, WIDTH_SOURCE, HEIGHT_SOURCE);
		videoDest   = new Rectangle(X_DEST  , Y_DEST  , WIDTH_DEST  , HEIGHT_DEST);
		
		awtVideoSize = new AWTVideoSize(videoSource, videoDest);
		
		AWTVideoSize VideoSizeCloned  = new AWTVideoSize(videoSource, videoDest);
		AWTVideoSize OtherVideoSize   = new AWTVideoSize(new Rectangle(1, 1, 1, 1), new Rectangle(1, 1, 1, 1));
		
		if(awtVideoSize.hashCode() == VideoSizeCloned.hashCode() &&  awtVideoSize.hashCode() != OtherVideoSize.hashCode())
			dtvTestLog.success();
		else
			dtvTestLog.failure();
	}

	public void pause() {
		// TODO Auto-generated method stub
	}

	public void destroy() {
		// TODO Auto-generated method stub
	}

	public void setForm(Form form) {
		// TODO Auto-generated method stub
		
	}

}
